/* ﭮ ᠭ 10a .99 ਭ (514/22) */
/*  N 1 (⮬) */

#include <stdio.h>
#include <string.h>

#define MAX_N	101
#define MAX_K	101

int r[MAX_K][MAX_N];

int main(int argc, char **argv)
{
	char fn[20];
	FILE *f;
	int n, k, new_t[MAX_K], new_spd[MAX_K], new_n = 0;
	int i, j, t, ln, lv;

	scanf("%s", fn);
	f = fopen(fn, "r");

	fscanf(f, "%d %d", &n, &k);
	while(fscanf(f, "%d %d", &new_t[new_n], &new_spd[new_n]) == 2)
		new_n++;

	fclose(f);

	memset(&r[0], -1, sizeof(int)*MAX_N);

	strcat(fn, ".out");
	f = fopen(fn, "w");

	/* Iterate through simulation steps */
	for (i = 1; i <= k; i++)
	{
		memcpy(&r[i], &r[i-1], sizeof(int)*MAX_N);

		/* Move all cars */
		for (j = n-1; j >= 0; j--)
		{
			if (r[i][j] != -1)
			{
				t = j + r[i][j];
				if (t >= n)
				{
					fprintf(stderr, "Ran to red light at time = %d\n", i);
					fclose(f);
					return (-1);
				}
				if (t == j)
					continue;
				if (r[i][t] != -1)
				{
					fprintf(stderr, "CRASH! (time = %d, x = %d)\n", i, j);
					fclose(f);
					return (-1);
				}
				r[i][t] = r[i][j];
				r[i][j] = -1;
			}
		}

		/* Add new cars if needed */
		for (j = 0; j < new_n; j++)
		{
			if (new_t[j] == i)
			{
				r[i][0] = new_spd[j];
			}
		}

		ln = 0; /* The very first car */


		/* Iterate through all cars; calculate new speed */
		for (j = n-1; j >= 0; j--)
		{
			if (r[i][j] != -1)
			{
				fprintf(f, "%s%d", ln ? " " : "", r[i][j]);
				/* The first car should care only about red light */
				if (!ln)
				{
					/* Find 'the critical point' */
					int pos = n, sp = 0;
					while (sp != r[i][j])
					{
						sp++;
						pos -= sp;
					}

					if (j > pos - sp)
						r[i][j]--;
					else if (j > pos - 2 * sp - 1)
						;
					else
						r[i][j]++;
					ln = j;
				}
				else
				/* Other cars should care only about another cars */
				{
					if (ln - j - 1 + (r[i][ln] - r[i][j]) > 0)
						r[i][j]--;
					else if (ln - j - 1 + (r[i][ln] - r[i][j]) < 0)
						r[i][j]++;
					ln = j;
				}
			}
		}
		fprintf(f, "\n");
	}

	fclose(f);

	return 0;
}
